%%
% ps-> n*3, as-> n*3
function p = BestPoint(ps,as)
    as = bsxfun(@rdivide,as,sqrt(sum(as.^2)));
    Skew = @(x) [0 -x(3) x(2);x(3) 0 -x(1);-x(2) x(1) 0];
    N = size(ps,2);
    A = zeros(3);
    B = zeros(3,1);
    for i = 1:N
        S = Skew(as(:,i))'*Skew(as(:,i));
        A = A + S;
        B = B + S*ps(:,i);
    end
    p = A\B;
end