%%
% ps-> n*3, as-> n*3
function p = BestPointWeighted(ps,as)
    as = bsxfun(@rdivide,as,sqrt(sum(as.^2)));
    Skew = @(x) [0 -x(3) x(2);x(3) 0 -x(1);-x(2) x(1) 0];
    N = size(ps,2);
    A = zeros(3);
    B = zeros(3,1);
    w = ones(1,N);
    for j = 1:10
        for i = 1:N
            S = Skew(as(:,i))'*Skew(as(:,i));
            A = A + w(i)*S;
            B = B + w(i)*S*ps(:,i);
        end
        p = A\B;
        w = 1./sum((ps-p).^2,1);
    end
end