function [s,R,m] = sR_m(pr,ps)
% s*R*ps - m = pr
% I = eye(3);
N = size(pr,2);
Mr = mean(pr,2);
Ms = mean(ps,2);
s = sqrt(sum(sum((pr-Mr).^2))/sum(sum((ps-Ms).^2)));
p1 = s*(ps-Ms)+Mr;

H = zeros(3,3);
for i = 1:N
    H = H + (p1(:,i)-Mr)*(pr(:,i)-Mr)';
end
[U,~,V] = svd(H);
% R = V*U'*det(V*U');
if det(V) < 0
V(:,3) = V(:,3) * -1;
end
R = V*U';

if size(pr,2)==2
    ax = cross(pr(:,2)-pr(:,1),randn(3,1));
    ax = ax/norm(ax);
    R2 = axang2rotm([ax' pi])*R;
    if norm(sqrt(sum((R*(p1-Mr)-(pr-Mr)).^2,2))) > norm(sqrt(sum((R2*(p1-Mr)-(pr-Mr)).^2,2)))
        R = R2;
    end
end

% s = s1;
m = s*R*Ms-Mr;

% A = [reshape(s*R*ps-m,[],1),-repmat(I,N,1)];
% b = reshape(pr,[],1);
% sm = A\b;
% s = sm(1)*s;
% if s < 0
%     s = -s;
%     R = -R;
% end
% m = sm(1)*m+sm(2:4);